<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Enumerated Types</TITLE>
<link href="suif1_67.html" rel=Next>
<link href="suif1_65.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_65.html">previous</A>, <A HREF="suif1_67.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC66" HREF="suif1_toc.html#TOC66">Enumerated Types</A></H2>
<P>
<A NAME="IDX488"></A>
<A NAME="IDX489"></A>

</P>
<P>
<A NAME="IDX490"></A>
Enumerated types are much like integer types, except that each member of
an enumeration is given a name.  The <CODE>TYPE_ENUM</CODE> operator is
classified as one of the base type operators, and the <CODE>enum_type</CODE>
class which it uses is derived from the <CODE>base_type</CODE> class.
See section <A HREF="suif1_61.html#SEC61">Base Types</A>.  Since an enumerated type behaves like an integer
type, the same <CODE>base_type</CODE> methods can be used to specify the size
and whether or not it is signed.

</P>
<P>
<A NAME="IDX491"></A>
<A NAME="IDX492"></A>
Like structures and unions, enumerated types are given names.  The
<CODE>name</CODE> method returns the name for an <CODE>enum_type</CODE>, which
should be different from the names of other types in the symbol table
where it is defined.  The <CODE>set_name</CODE> method automatically enters
the name in the lexicon (see section <A HREF="suif1_102.html#SEC102">Lexicon</A>).

</P>
<P>
<A NAME="IDX493"></A>
<A NAME="IDX494"></A>
<A NAME="IDX495"></A>
<A NAME="IDX496"></A>
<A NAME="IDX497"></A>
<A NAME="IDX498"></A>
Each enumerated type contains arrays to hold the names and values of its
members.  The <CODE>num_values</CODE> method returns the number of members.
The <CODE>set_num_values</CODE> method may be called at any time to change the
number of members.  It will allocate more space for the arrays if
necessary.  The <CODE>member</CODE> method returns the name of a particular
member, and the <CODE>value</CODE> method returns its value.  The members are
numbered beginning with zero.  The <CODE>set_member</CODE> method changes the
name of a member and enters the new name in the lexicon.  Similarly, the
<CODE>set_value</CODE> method changes the value for a method.  All of the
values must fit within the size of the type, and negative values are not
allowed with unsigned enumerations.

</P>
<P>
<A NAME="IDX499"></A>
<A NAME="IDX500"></A>
The <CODE>find_member_by_name</CODE> method searches through the members of an
enumerated type for a particular name.  If successful, it returns the
index of the member; otherwise, it returns a value of <CODE>-1</CODE>.  The
<CODE>find_member_by_value</CODE> method returns the index of the first member
that it finds with a certain value.  If the value is not found, it
returns a value of <CODE>-1</CODE>, just like <CODE>find_member_by_name</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_65.html">previous</A>, <A HREF="suif1_67.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
